
import * as $calcit from "./calcit.core.mjs";
import * as $app_DOT_schema from "./app.schema.mjs";
var _kwd={};
["base-dir","code","commands","draft","id","name","path","title","workflow-id","workflows",].forEach(x => {
  _kwd[x] = $calcit.kwd(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export function add_command(db, op_data, sid, op_id, op_time) { 
if (arguments.length !== 5) throw _calcit_args_mismatch('add-command', 5, arguments.length);
let result__1 = op_data;
(function __fn__(){
( $calcit.not($calcit.string_$q_($calcit.str("expected map for destructing: ", result__1))) ? (function __fn__(){
let err_AUTO_1 = new Error("expects 1st argument to be string");
 err_AUTO_1.data = null;
 throw err_AUTO_1;
})() : null );

if ($calcit.map_$q_(result__1)) { return null }else { console.error($calcit.printable("Failed assertion:", $calcit.format_to_lisp(new $calcit.CalcitSliceList([new $calcit.CalcitSymbol("map?"), new $calcit.CalcitSymbol("result__1")]))));
let err_AUTO_2 = new Error("([] 'str \"|expected map for destructing: \" 'result__1) (map? result__1)");
 err_AUTO_2.data = null;
 throw err_AUTO_2;
 }

})();
let workflow_id = $calcit.get(result__1, _kwd["workflow-id"]);
let draft = $calcit.get(result__1, _kwd["draft"]);
return $calcit.assoc_in(db, $calcit._$L_(_kwd["workflows"], workflow_id, _kwd["commands"], op_id), $calcit.merge(draft, $calcit._$n__$M_(_kwd["id"], op_id)))


}
export function create_workflow(db, op_data, sid, op_id, op_time) { 
if (arguments.length !== 5) throw _calcit_args_mismatch('create-workflow', 5, arguments.length);
let workflow_name = $calcit.get(op_data, _kwd["name"]);
let base_dir = $calcit.get(op_data, _kwd["base-dir"]);
return $calcit.assoc_in(db, $calcit._$L_(_kwd["workflows"], op_id), $calcit.merge($app_DOT_schema.workflow, $calcit._$n__$M_(_kwd["id"], op_id, _kwd["name"], workflow_name, _kwd["base-dir"], base_dir, _kwd["commands"], $calcit._$n__$M_(op_id, $calcit.merge($app_DOT_schema.command, $calcit._$n__$M_(_kwd["id"], op_id, _kwd["title"], workflow_name, _kwd["path"], base_dir, _kwd["code"], "echo nothing yet"))))))

}
export function edit_command(db, op_data, sid, op_id, op_time) { 
if (arguments.length !== 5) throw _calcit_args_mismatch('edit-command', 5, arguments.length);
let workflow_id = $calcit._$n_list_$o_nth(op_data, 0);
let command_id = $calcit._$n_list_$o_nth(op_data, 1);
let changes = $calcit._$n_list_$o_nth(op_data, 2);
return $calcit.update_in(db, $calcit._$L_(_kwd["workflows"], workflow_id, _kwd["commands"], command_id), function f_PCT_(command) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.merge(command, changes)
}
)

}
export function edit_workflow(db, op_data, sid, op_id, op_time) { 
if (arguments.length !== 5) throw _calcit_args_mismatch('edit-workflow', 5, arguments.length);
let new_workflow = op_data;
return $calcit.update_in(db, $calcit._$L_(_kwd["workflows"], $calcit.get(new_workflow, _kwd["id"])), function f_PCT_(workflow) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.merge(workflow, new_workflow)
}
)

}
export function remove_command(db, op_data, sid, op_id, op_time) { 
if (arguments.length !== 5) throw _calcit_args_mismatch('remove-command', 5, arguments.length);
let workflow_id = $calcit._$n_list_$o_nth(op_data, 0);
let command_id = $calcit._$n_list_$o_nth(op_data, 1);
return $calcit.update_in(db, $calcit._$L_(_kwd["workflows"], workflow_id, _kwd["commands"]), function f_PCT_(commands) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.dissoc(commands, command_id)
}
)

}
export function remove_workflow(db, op_data, sid, op_id, op_time) { 
if (arguments.length !== 5) throw _calcit_args_mismatch('remove-workflow', 5, arguments.length);
let workflow_id = op_data;
return $calcit.update(db, _kwd["workflows"], function f_PCT_(workflows) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.dissoc(workflows, workflow_id)
}
)

}



