
import {kwd, arrayToList, listToArray, CalcitSliceList, CalcitSymbol, CalcitRecur} from "@calcit/procs";
import * as $calcit_procs from "@calcit/procs";
export * from "@calcit/procs";

var _kwd={};
["&core-fn-class","&core-list-class","&core-map-class","&core-nil-class","&core-number-class","&core-record-class","&core-set-class","&core-string-class","add","any?","append","apply","assoc","assoc-after","assoc-before","bind","blank?","butlast","call","call-args","ceil","common-keys","concat","contains?","count","diff-keys","diff-new","difference","display-by","dissoc","drop","each","empty","empty?","ends-with?","escape","exclude","extend-as","filter","filter-kv","filter-not","filter-pair","find","find-index","find-last","find-last-index","first","flatten","floor","foldl","format","fract","from-map","get","get-char-code","get-in","get-name","group-by","inc","include","includes?","index-of","intersection","join","join-str","keys","last-index-of","map","map-indexed","map-kv","map-list","map-pair","mappend","matches?","max","merge","min","negate","nth","pad-left","pad-right","pairs-map","parse-float","pow","prepend","reduce","rem","replace","rest","reverse","round","round?","slice","sort","sort-by","split","split-lines","sqrt","starts-with?","strip-prefix","strip-suffix","symbol","take","take-last","to-list","to-map","to-number","to-pairs","to-set","to-string","trim","union","values",].forEach(x => {
  _kwd[x] = kwd(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export function _$n__LT__$e_(a, b) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&<=', 2, arguments.length);

if ($calcit_procs._$n__LT_(a, b)) { return true }else { return $calcit_procs._$n__$e_(a, b) }
}
export function _$n__GT__$e_(a, b) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&>=', 2, arguments.length);

if ($calcit_procs._$n__GT_(a, b)) { return true }else { return $calcit_procs._$n__$e_(a, b) }
}
export function reduce(xs, x0, f) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('reduce', 3, arguments.length);
return $calcit_procs.foldl(xs, x0, f)
}
export function _$n_list_$o_filter(xs, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&list:filter', 2, arguments.length);
return reduce(xs, $calcit_procs._$L_(), function _PCT__$n_list_$o_filter(acc, x) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('%&list:filter', 2, arguments.length);

if (f(x)) { return $calcit_procs.append(acc, x) }else { return acc }
}
)
}
export let foldl_compare = function foldl_compare(xs, acc, f) {
  
if (arguments.length !== 3) throw _calcit_args_mismatch('foldl-compare', 3, arguments.length);
  
  let times_AUTO_3 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_2 = null;
    if (times_AUTO_3 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    
if ($calcit_procs._$n_list_$o_empty_$q_(xs)) { ret_AUTO_2 =true }
 else if (f(acc, $calcit_procs._$n_list_$o_first(xs))) { ret_AUTO_2 =$calcit_procs.recur($calcit_procs._$n_list_$o_rest(xs), $calcit_procs._$n_list_$o_first(xs), f) }else { ret_AUTO_2 =false }

    if (ret_AUTO_2 instanceof CalcitRecur) {
      
if (ret_AUTO_2.args.length !== 3) throw _calcit_args_mismatch('foldl-compare', 3, ret_AUTO_2.args.length);
      [ xs, acc, f ] = ret_AUTO_2.args;
      
      times_AUTO_3 += 1;
      continue;
    } else {
      return ret_AUTO_2;
    }
  }
}

export function _$e_(x, ...ys) { 
if (arguments.length < 1) throw new Error('too few arguments');
ys = arrayToList(ys);

if ($calcit_procs._$n__$e_(1, $calcit_procs._$n_list_$o_count(ys))) { return $calcit_procs._$n__$e_(x, $calcit_procs._$n_list_$o_first(ys)) }else { return foldl_compare(ys, x, $calcit_procs._$n__$e_) }
}

var list_$q_ = $calcit_procs.list_$q_;

var nil_$q_ = $calcit_procs.nil_$q_;

var tuple_$q_ = $calcit_procs.tuple_$q_;
export function count(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('count', 1, arguments.length);

if (nil_$q_(x)) { return 0 }
 else if (tuple_$q_(x)) { return 2 }
 else if (list_$q_(x)) { return $calcit_procs._$n_list_$o_count(x) }else { return $calcit_procs.invoke_method("count",x,) }
}
export function nth(x, i) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('nth', 2, arguments.length);

if (tuple_$q_(x)) { return $calcit_procs._$n_tuple_$o_nth(x, i) }
 else if (list_$q_(x)) { return $calcit_procs._$n_list_$o_nth(x, i) }else { return $calcit_procs.invoke_method("nth",x,i) }
}

var string_$q_ = $calcit_procs.string_$q_;
export function _$n_list_$o_filter_pair(xs, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&list:filter-pair', 2, arguments.length);

if (list_$q_(xs)) { return _$n_list_$o_filter(xs, function _PCT_filter_pair(pair) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('%filter-pair', 1, arguments.length);
(function __fn__(){
( $calcit_procs.not(string_$q_("expected a pair")) ? (function __fn__(){
let err_AUTO_4 = new Error("expects 1st argument to be string");
 err_AUTO_4.data = null;
 throw err_AUTO_4;
})() : null );

if (( list_$q_(pair) ? (function __fn__(){
let v1__6 = _$e_(2, count(pair));

if (v1__6) { return v1__6 }else { return false }

})() : false )) { return null }else { console.error($calcit_procs.printable("Failed assertion:", $calcit_procs.format_to_lisp(new CalcitSliceList([new CalcitSymbol("and"), new CalcitSliceList([new CalcitSymbol("list?"), new CalcitSymbol("pair")]), new CalcitSliceList([new CalcitSymbol("="), 2, new CalcitSliceList([new CalcitSymbol("count"), new CalcitSymbol("pair")])])]))));
let err_AUTO_5 = new Error("expected a pair (and (list? pair) (= 2 (count pair)))");
 err_AUTO_5.data = null;
 throw err_AUTO_5;
 }

})();
return f(nth(pair, 0), nth(pair, 1))
}
) }else { let err_AUTO_6 = new Error("expected list or map from `filter-pair`");
 err_AUTO_6.data = null;
 throw err_AUTO_6; }
}
export function _$n_list_$o_find_last(xs, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&list:find-last', 2, arguments.length);
return $calcit_procs.foldr_shortcut(xs, null, null, function f_PCT_(_acc, x) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);

if (f(x)) { return $calcit_procs._$o__$o_(true, x) }else { return $calcit_procs._$o__$o_(false, null) }
}
)
}
export function dec(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('dec', 1, arguments.length);
return $calcit_procs._$n__(x, 1)
}
export function _$n_list_$o_find_last_index(xs, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&list:find-last-index', 2, arguments.length);
return $calcit_procs.foldr_shortcut(xs, dec(count(xs)), null, function f_PCT_(idx, x) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);

if (f(x)) { return $calcit_procs._$o__$o_(true, idx) }else { return $calcit_procs._$o__$o_(false, $calcit_procs._$n__(1, idx)) }
}
)
}
export function _$n_list_$o_map(xs, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&list:map', 2, arguments.length);
return $calcit_procs.foldl(xs, $calcit_procs._$L_(), function _PCT__$n_list_$o_map(acc, x) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('%&list:map', 2, arguments.length);
return $calcit_procs.append(acc, f(x))
}
)
}
export function _$n_map_$o_map(xs, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&map:map', 2, arguments.length);
return $calcit_procs.foldl(xs, $calcit_procs._$n__$M_(), function _$n_map_$o_map(acc, pair) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&map:map', 2, arguments.length);
let result = f(pair);
(function __fn__(){
( $calcit_procs.not(string_$q_("expected pair returned when mapping hashmap")) ? (function __fn__(){
let err_AUTO_7 = new Error("expects 1st argument to be string");
 err_AUTO_7.data = null;
 throw err_AUTO_7;
})() : null );

if (( list_$q_(result) ? (function __fn__(){
let v1__1 = $calcit_procs._$n__$e_(2, $calcit_procs._$n_list_$o_count(result));

if (v1__1) { return v1__1 }else { return false }

})() : false )) { return null }else { console.error($calcit_procs.printable("Failed assertion:", $calcit_procs.format_to_lisp(new CalcitSliceList([new CalcitSymbol("and"), new CalcitSliceList([new CalcitSymbol("list?"), new CalcitSymbol("result")]), new CalcitSliceList([new CalcitSymbol("&="), 2, new CalcitSliceList([new CalcitSymbol("&list:count"), new CalcitSymbol("result")])])]))));
let err_AUTO_8 = new Error("expected pair returned when mapping hashmap (and (list? result) (&= 2 (&list:count result)))");
 err_AUTO_8.data = null;
 throw err_AUTO_8;
 }

})();
return $calcit_procs._$n_map_$o_assoc(acc, nth(result, 0), nth(result, 1))

}
)
}
export function include(base, ...xs) { 
if (arguments.length < 1) throw new Error('too few arguments');
xs = arrayToList(xs);
return reduce(xs, base, function f_PCT_(acc, item) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
return $calcit_procs._$n_include(acc, item)
}
)
}

var map_$q_ = $calcit_procs.map_$q_;

var set_$q_ = $calcit_procs.set_$q_;
export function map(xs, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('map', 2, arguments.length);

if (list_$q_(xs)) { return _$n_list_$o_map(xs, f) }
 else if (set_$q_(xs)) { return $calcit_procs.foldl(xs, $calcit_procs._SHA__$M_(), function _PCT_map(acc, x) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('%map', 2, arguments.length);
return include(acc, f(x))
}
) }
 else if (map_$q_(xs)) { return _$n_map_$o_map(xs, f) }else { console.log($calcit_procs.printable("value:", xs));
let err_AUTO_9 = new Error("expected list or set for map function");
 err_AUTO_9.data = null;
 throw err_AUTO_9;
 }
}
export function _$n_list_$o_flatten(xs) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('&list:flatten', 1, arguments.length);

if (list_$q_(xs)) { return $calcit_procs._$n_list_$o_concat(...listToArray(map(xs, _$n_list_$o_flatten))) }else { return $calcit_procs._$L_(xs) }
}
export function _$n_list_$o_last_index_of(xs, item) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&list:last-index-of', 2, arguments.length);
return $calcit_procs.foldr_shortcut(xs, dec(count(xs)), null, function f_PCT_(idx, x) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);

if ($calcit_procs._$n__$e_(item, x)) { return $calcit_procs._$o__$o_(true, idx) }else { return $calcit_procs._$o__$o_(false, $calcit_procs._$n__(1, idx)) }
}
)
}
export function _$n_list_$o_map_pair(xs, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&list:map-pair', 2, arguments.length);

if (list_$q_(xs)) { return map(xs, function _PCT_map_pair(pair) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('%map-pair', 1, arguments.length);
(function __fn__(){
( $calcit_procs.not(string_$q_("expected a pair")) ? (function __fn__(){
let err_AUTO_10 = new Error("expects 1st argument to be string");
 err_AUTO_10.data = null;
 throw err_AUTO_10;
})() : null );

if (( list_$q_(pair) ? (function __fn__(){
let v1__5 = _$e_(2, count(pair));

if (v1__5) { return v1__5 }else { return false }

})() : false )) { return null }else { console.error($calcit_procs.printable("Failed assertion:", $calcit_procs.format_to_lisp(new CalcitSliceList([new CalcitSymbol("and"), new CalcitSliceList([new CalcitSymbol("list?"), new CalcitSymbol("pair")]), new CalcitSliceList([new CalcitSymbol("="), 2, new CalcitSliceList([new CalcitSymbol("count"), new CalcitSymbol("pair")])])]))));
let err_AUTO_11 = new Error("expected a pair (and (list? pair) (= 2 (count pair)))");
 err_AUTO_11.data = null;
 throw err_AUTO_11;
 }

})();
return f(nth(pair, 0), nth(pair, 1))
}
) }else { let err_AUTO_12 = new Error("expected list or map from `map-pair`");
 err_AUTO_12.data = null;
 throw err_AUTO_12; }
}

var number_$q_ = $calcit_procs.number_$q_;
export function _$n_max(a, b) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&max', 2, arguments.length);
(function __fn__(){
( $calcit_procs.not(string_$q_("expects numbers for &max")) ? (function __fn__(){
let err_AUTO_13 = new Error("expects 1st argument to be string");
 err_AUTO_13.data = null;
 throw err_AUTO_13;
})() : null );

if ((function __fn__(){

if (number_$q_(a)) { return number_$q_(b) }
 else if (string_$q_(a)) { return string_$q_(b) }else { return false }
})()) { return null }else { console.error($calcit_procs.printable("Failed assertion:", $calcit_procs.format_to_lisp(new CalcitSliceList([new CalcitSymbol("if"), new CalcitSliceList([new CalcitSymbol("number?"), new CalcitSymbol("a")]), new CalcitSliceList([new CalcitSymbol("number?"), new CalcitSymbol("b")]), new CalcitSliceList([new CalcitSymbol("if"), new CalcitSliceList([new CalcitSymbol("string?"), new CalcitSymbol("a")]), new CalcitSliceList([new CalcitSymbol("string?"), new CalcitSymbol("b")]), false])]))));
let err_AUTO_14 = new Error("expects numbers for &max (if (number? a) (number? b) (if (string? a) (string? b) false))");
 err_AUTO_14.data = null;
 throw err_AUTO_14;
 }

})();

if ($calcit_procs._$n__GT_(a, b)) { return a }else { return b }
}
export function _$n_list_$o_max(xs) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('&list:max', 1, arguments.length);

if ($calcit_procs._$n_list_$o_empty_$q_(xs)) { return null }else { return reduce($calcit_procs._$n_list_$o_rest(xs), $calcit_procs._$n_list_$o_first(xs), function _PCT_max(acc, x) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('%max', 2, arguments.length);
return _$n_max(acc, x)
}
) }
}
export function _$n_min(a, b) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&min', 2, arguments.length);
(function __fn__(){
( $calcit_procs.not(string_$q_("expects numbers for &min")) ? (function __fn__(){
let err_AUTO_15 = new Error("expects 1st argument to be string");
 err_AUTO_15.data = null;
 throw err_AUTO_15;
})() : null );

if ((function __fn__(){

if (number_$q_(a)) { return number_$q_(b) }
 else if (string_$q_(a)) { return string_$q_(b) }else { return false }
})()) { return null }else { console.error($calcit_procs.printable("Failed assertion:", $calcit_procs.format_to_lisp(new CalcitSliceList([new CalcitSymbol("if"), new CalcitSliceList([new CalcitSymbol("number?"), new CalcitSymbol("a")]), new CalcitSliceList([new CalcitSymbol("number?"), new CalcitSymbol("b")]), new CalcitSliceList([new CalcitSymbol("if"), new CalcitSliceList([new CalcitSymbol("string?"), new CalcitSymbol("a")]), new CalcitSliceList([new CalcitSymbol("string?"), new CalcitSymbol("b")]), false])]))));
let err_AUTO_16 = new Error("expects numbers for &min (if (number? a) (number? b) (if (string? a) (string? b) false))");
 err_AUTO_16.data = null;
 throw err_AUTO_16;
 }

})();

if ($calcit_procs._$n__LT_(a, b)) { return a }else { return b }
}
export function _$n_list_$o_min(xs) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('&list:min', 1, arguments.length);

if ($calcit_procs._$n_list_$o_empty_$q_(xs)) { return null }else { return reduce($calcit_procs._$n_list_$o_rest(xs), $calcit_procs._$n_list_$o_first(xs), function _PCT_min(acc, x) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('%min', 2, arguments.length);
return _$n_min(acc, x)
}
) }
}

var record_$q_ = $calcit_procs.record_$q_;
export function get(base, k) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('get', 2, arguments.length);

if (nil_$q_(base)) { return null }
 else if (string_$q_(base)) { return $calcit_procs._$n_str_$o_nth(base, k) }
 else if (map_$q_(base)) { return $calcit_procs._$n_map_$o_get(base, k) }
 else if (list_$q_(base)) { return $calcit_procs._$n_list_$o_nth(base, k) }
 else if (tuple_$q_(base)) { return $calcit_procs._$n_tuple_$o_nth(base, k) }
 else if (record_$q_(base)) { return $calcit_procs._$n_record_$o_get(base, k) }else { console.error($calcit_procs.printable("Value:", base, k));
let err_AUTO_17 = new Error("Expected map or list for get");
 err_AUTO_17.data = null;
 throw err_AUTO_17;
 }
}

var keyword_$q_ = $calcit_procs.keyword_$q_;
export function _$n_list_$o_sort_by(xs, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&list:sort-by', 2, arguments.length);

if (keyword_$q_(f)) { return $calcit_procs.sort(xs, function _PCT__$n_list_$o_sort_by(a, b) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('%&list:sort-by', 2, arguments.length);
return $calcit_procs._$n_compare(get(a, f), get(b, f))
}
) }else { return $calcit_procs.sort(xs, function _PCT__$n_list_$o_sort_by(a, b) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('%&list:sort-by', 2, arguments.length);
return $calcit_procs._$n_compare(f(a), f(b))
}
) }
}
export function _SUB_(x, ...ys) { 
if (arguments.length < 1) throw new Error('too few arguments');
ys = arrayToList(ys);

if ($calcit_procs._$n_list_$o_empty_$q_(ys)) { return $calcit_procs._$n__(0, x) }else { return reduce(ys, x, $calcit_procs._$n__) }
}
export function _GT__$e_(x, ...ys) { 
if (arguments.length < 1) throw new Error('too few arguments');
ys = arrayToList(ys);

if ($calcit_procs._$n__$e_(1, $calcit_procs._$n_list_$o_count(ys))) { return _$n__GT__$e_(x, $calcit_procs._$n_list_$o_first(ys)) }else { return foldl_compare(ys, x, _$n__GT__$e_) }
}
export function any_$q_(xs, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('any?', 2, arguments.length);
return $calcit_procs.foldl_shortcut(xs, null, false, function _PCT_any_$q_(_acc, x) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('%any?', 2, arguments.length);

if (f(x)) { return $calcit_procs._$o__$o_(true, true) }else { return $calcit_procs._$o__$o_(false, null) }
}
)
}
export function assoc(x, ...args) { 
if (arguments.length < 1) throw new Error('too few arguments');
args = arrayToList(args);

if (nil_$q_(x)) { let err_AUTO_18 = new Error("assoc does not work on nil");
 err_AUTO_18.data = null;
 throw err_AUTO_18; }
 else if (tuple_$q_(x)) { return $calcit_procs._$n_tuple_$o_assoc(x, ...listToArray(args)) }
 else if (list_$q_(x)) { return $calcit_procs._$n_list_$o_assoc(x, ...listToArray(args)) }else { return $calcit_procs.invoke_method("assoc",x,...listToArray(args)) }
}
export function contains_$q_(x, k) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('contains?', 2, arguments.length);

if (nil_$q_(x)) { return false }
 else if (list_$q_(x)) { return $calcit_procs._$n_list_$o_contains_$q_(x, k) }
 else if (tuple_$q_(x)) { let v1__3 = $calcit_procs._$n__$e_(k, 0);

if (nil_$q_(v1__3)) { return $calcit_procs._$n__$e_(k, 1) }
 else if (_$e_(false, v1__3)) { return $calcit_procs._$n__$e_(k, 1) }else { return v1__3 }
 }else { return $calcit_procs.invoke_method("contains?",x,k) }
}
export function slice(xs, n, m) { 
if (arguments.length < 2) throw new Error('too few arguments');
if (arguments.length > 3) throw new Error('too many arguments');

if (nil_$q_(xs)) { return null }else { return $calcit_procs.invoke_method("slice",xs,n, m) }
}
export function drop(xs, n) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('drop', 2, arguments.length);
return slice(xs, n, $calcit_procs._$n_list_$o_count(xs))
}
export function each(xs, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('each', 2, arguments.length);
return $calcit_procs.foldl(xs, null, function _PCT_each(_acc, x) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('%each', 2, arguments.length);
return f(x)
}
)
}
export function empty_$q_(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('empty?', 1, arguments.length);

if (nil_$q_(x)) { return true }
 else if (list_$q_(x)) { return $calcit_procs._$n_list_$o_empty_$q_(x) }else { return $calcit_procs.invoke_method("empty?",x,) }
}
export function filter_not(xs, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('filter-not', 2, arguments.length);
return $calcit_procs.invoke_method("filter",xs,function _PCT_filter_not(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('%filter-not', 1, arguments.length);
return $calcit_procs.not(f(x))
}
)
}
export function find(xs, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('find', 2, arguments.length);
return $calcit_procs.foldl_shortcut(xs, 0, null, function _PCT_find(_acc, x) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('%find', 2, arguments.length);

if (f(x)) { return $calcit_procs._$o__$o_(true, x) }else { return $calcit_procs._$o__$o_(false, null) }
}
)
}
export function find_index(xs, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('find-index', 2, arguments.length);
return $calcit_procs.foldl_shortcut(xs, 0, null, function _PCT_find_index(idx, x) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('%find-index', 2, arguments.length);

if (f(x)) { return $calcit_procs._$o__$o_(true, idx) }else { return $calcit_procs._$o__$o_(false, $calcit_procs._$n__ADD_(1, idx)) }
}
)
}
export function rest(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('rest', 1, arguments.length);

if (nil_$q_(x)) { return null }
 else if (list_$q_(x)) { return $calcit_procs._$n_list_$o_rest(x) }else { return $calcit_procs.invoke_method("rest",x,) }
}
export let get_in = function get_in(base, path) {
  
if (arguments.length !== 2) throw _calcit_args_mismatch('get-in', 2, arguments.length);
  
  let times_AUTO_22 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_21 = null;
    if (times_AUTO_22 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    ( $calcit_procs.not(list_$q_(path)) ? (function __fn__(){
console.error($calcit_procs.printable("Pattern:", path));
let err_AUTO_20 = new Error("expects path in a list");
 err_AUTO_20.data = null;
 throw err_AUTO_20;

})() : null );

if (nil_$q_(base)) { ret_AUTO_21 =null }
 else if ($calcit_procs._$n_list_$o_empty_$q_(path)) { ret_AUTO_21 =base }else { ret_AUTO_21 =$calcit_procs.recur(get(base, $calcit_procs._$n_list_$o_first(path)), rest(path)) }

    if (ret_AUTO_21 instanceof CalcitRecur) {
      
if (ret_AUTO_21.args.length !== 2) throw _calcit_args_mismatch('get-in', 2, ret_AUTO_21.args.length);
      [ base, path ] = ret_AUTO_21.args;
      
      times_AUTO_22 += 1;
      continue;
    } else {
      return ret_AUTO_21;
    }
  }
}

export function update(x, k, f) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('update', 3, arguments.length);

if (map_$q_(x)) { 
if (contains_$q_(x, k)) { return assoc(x, k, f($calcit_procs._$n_map_$o_get(x, k))) }else { return x } }
 else if (list_$q_(x)) { 
if ($calcit_procs._$n_list_$o_contains_$q_(x, k)) { return assoc(x, k, f($calcit_procs._$n_list_$o_nth(x, k))) }else { return x } }
 else if (tuple_$q_(x)) { 
if ((function __fn__(){
let v1__4 = $calcit_procs._$n__$e_(k, 0);

if (nil_$q_(v1__4)) { return $calcit_procs._$n__$e_(k, 1) }
 else if (_$e_(false, v1__4)) { return $calcit_procs._$n__$e_(k, 1) }else { return v1__4 }

})()) { return assoc(x, k, f($calcit_procs._$n_tuple_$o_nth(x, k))) }else { let err_AUTO_23 = new Error($calcit_procs._$n_str_$o_concat("tuple only has 0,1 fields, unknown field: ", k));
 err_AUTO_23.data = null;
 throw err_AUTO_23; } }
 else if (record_$q_(x)) { 
if (contains_$q_(x, k)) { return assoc(x, k, f($calcit_procs._$n_record_$o_get(x, k))) }else { return x } }else { let err_AUTO_24 = new Error($calcit_procs._$n_str_$o_concat("Cannot update key on item: ", $calcit_procs.pr_str(x)));
 err_AUTO_24.data = null;
 throw err_AUTO_24; }
}
export function group_by(xs0, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('group-by', 2, arguments.length);
return function _PCT_group_by(acc, xs) {
  
if (arguments.length !== 2) throw _calcit_args_mismatch('%group-by', 2, arguments.length);
  
  let times_AUTO_27 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_26 = null;
    if (times_AUTO_27 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    
if ($calcit_procs._$n_list_$o_empty_$q_(xs)) { ret_AUTO_26 =acc }else { let x0 = $calcit_procs._$n_list_$o_first(xs);
let key = f(x0);
ret_AUTO_26 =$calcit_procs.recur(( contains_$q_(acc, key) ? update(acc, key, function _PCT__BSL_(_PCT_, _PCT_2) { 
if (arguments.length < 0) throw new Error('too few arguments');
if (arguments.length > 2) throw new Error('too many arguments');
return $calcit_procs.append(_PCT_, x0)
}
) : $calcit_procs._$n_map_$o_assoc(acc, key, $calcit_procs._$L_(x0)) ), rest(xs))
 }

    if (ret_AUTO_26 instanceof CalcitRecur) {
      
if (ret_AUTO_26.args.length !== 2) throw _calcit_args_mismatch('%group-by', 2, ret_AUTO_26.args.length);
      [ acc, xs ] = ret_AUTO_26.args;
      
      times_AUTO_27 += 1;
      continue;
    } else {
      return ret_AUTO_26;
    }
  }
}

($calcit_procs._$n__$M_(), xs0)
}
export function identity(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('identity', 1, arguments.length);
return x
}
export function index_of(xs, item) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('index-of', 2, arguments.length);
return $calcit_procs.foldl_shortcut(xs, 0, null, function _PCT_index_of(idx, x) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('%index-of', 2, arguments.length);

if ($calcit_procs._$n__$e_(item, x)) { return $calcit_procs._$o__$o_(true, idx) }else { return $calcit_procs._$o__$o_(false, $calcit_procs._$n__ADD_(1, idx)) }
}
)
}
export function join(xs0, sep) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('join', 2, arguments.length);
return function _PCT_join(acc, xs, beginning_$q_) {
  
if (arguments.length !== 3) throw _calcit_args_mismatch('%join', 3, arguments.length);
  
  let times_AUTO_30 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_29 = null;
    if (times_AUTO_30 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    
if ($calcit_procs._$n_list_$o_empty_$q_(xs)) { ret_AUTO_29 =acc }else { ret_AUTO_29 =$calcit_procs.recur($calcit_procs.append(( beginning_$q_ ? acc : $calcit_procs.append(acc, sep) ), $calcit_procs._$n_list_$o_first(xs)), $calcit_procs._$n_list_$o_rest(xs), false) }

    if (ret_AUTO_29 instanceof CalcitRecur) {
      
if (ret_AUTO_29.args.length !== 3) throw _calcit_args_mismatch('%join', 3, ret_AUTO_29.args.length);
      [ acc, xs, beginning_$q_ ] = ret_AUTO_29.args;
      
      times_AUTO_30 += 1;
      continue;
    } else {
      return ret_AUTO_29;
    }
  }
}

($calcit_procs._$L_(), xs0, true)
}
export function join_str(xs0, sep) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('join-str', 2, arguments.length);
return function _PCT_join_str(acc, xs, beginning_$q_) {
  
if (arguments.length !== 3) throw _calcit_args_mismatch('%join-str', 3, arguments.length);
  
  let times_AUTO_33 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_32 = null;
    if (times_AUTO_33 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    
if ($calcit_procs._$n_list_$o_empty_$q_(xs)) { ret_AUTO_32 =acc }else { ret_AUTO_32 =$calcit_procs.recur($calcit_procs._$n_str_$o_concat(( beginning_$q_ ? acc : $calcit_procs._$n_str_$o_concat(acc, sep) ), $calcit_procs._$n_list_$o_first(xs)), $calcit_procs._$n_list_$o_rest(xs), false) }

    if (ret_AUTO_32 instanceof CalcitRecur) {
      
if (ret_AUTO_32.args.length !== 3) throw _calcit_args_mismatch('%join-str', 3, ret_AUTO_32.args.length);
      [ acc, xs, beginning_$q_ ] = ret_AUTO_32.args;
      
      times_AUTO_33 += 1;
      continue;
    } else {
      return ret_AUTO_32;
    }
  }
}

("", xs0, true)
}
export function last(xs) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('last', 1, arguments.length);

if (empty_$q_(xs)) { return null }else { return nth(xs, $calcit_procs._$n__(count(xs), 1)) }
}
export function map_indexed(xs, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('map-indexed', 2, arguments.length);
return $calcit_procs.foldl(xs, $calcit_procs._$L_(), function _PCT_map_indexed(acc, x) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('%map-indexed', 2, arguments.length);
return $calcit_procs.append(acc, f(count(acc), x))
}
)
}
export function mapcat(xs, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('mapcat', 2, arguments.length);
return $calcit_procs._$n_list_$o_concat(...listToArray(map(xs, f)))
}
export function pairs_map(xs) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('pairs-map', 1, arguments.length);
return reduce(xs, $calcit_procs._$n__$M_(), function _PCT_pairs_map(acc, pair) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('%pairs-map', 2, arguments.length);
(function __fn__(){
( $calcit_procs.not(string_$q_("expects pair for pairs-map")) ? (function __fn__(){
let err_AUTO_34 = new Error("expects 1st argument to be string");
 err_AUTO_34.data = null;
 throw err_AUTO_34;
})() : null );

if (( list_$q_(pair) ? $calcit_procs._$n__$e_(2, $calcit_procs._$n_list_$o_count(pair)) : false )) { return null }else { console.error($calcit_procs.printable("Failed assertion:", $calcit_procs.format_to_lisp(new CalcitSliceList([new CalcitSymbol("if"), new CalcitSliceList([new CalcitSymbol("list?"), new CalcitSymbol("pair")]), new CalcitSliceList([new CalcitSymbol("&="), 2, new CalcitSliceList([new CalcitSymbol("&list:count"), new CalcitSymbol("pair")])]), false]))));
let err_AUTO_35 = new Error("expects pair for pairs-map (if (list? pair) (&= 2 (&list:count pair)) false)");
 err_AUTO_35.data = null;
 throw err_AUTO_35;
 }

})();
return $calcit_procs._$n_map_$o_assoc(acc, $calcit_procs._$n_list_$o_first(pair), last(pair))
}
)
}
export function take(xs, n) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('take', 2, arguments.length);

if (_GT__$e_(n, $calcit_procs._$n_list_$o_count(xs))) { return xs }else { return slice(xs, 0, n) }
}
export function take_last(xs, n) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('take-last', 2, arguments.length);

if (_GT__$e_(n, $calcit_procs._$n_list_$o_count(xs))) { return xs }else { return slice(xs, _SUB_($calcit_procs._$n_list_$o_count(xs), n), $calcit_procs._$n_list_$o_count(xs)) }
}
export function _$n_map_$o_add_entry(xs, pair) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&map:add-entry', 2, arguments.length);
(function __fn__(){
( $calcit_procs.not(string_$q_("&map:add-entry expected value in a pair")) ? (function __fn__(){
let err_AUTO_36 = new Error("expects 1st argument to be string");
 err_AUTO_36.data = null;
 throw err_AUTO_36;
})() : null );

if (( list_$q_(pair) ? (function __fn__(){
let v1__7 = $calcit_procs._$n__$e_(2, count(pair));

if (v1__7) { return v1__7 }else { return false }

})() : false )) { return null }else { console.error($calcit_procs.printable("Failed assertion:", $calcit_procs.format_to_lisp(new CalcitSliceList([new CalcitSymbol("and"), new CalcitSliceList([new CalcitSymbol("list?"), new CalcitSymbol("pair")]), new CalcitSliceList([new CalcitSymbol("&="), 2, new CalcitSliceList([new CalcitSymbol("count"), new CalcitSymbol("pair")])])]))));
let err_AUTO_37 = new Error("&map:add-entry expected value in a pair (and (list? pair) (&= 2 (count pair)))");
 err_AUTO_37.data = null;
 throw err_AUTO_37;
 }

})();
return $calcit_procs._$n_map_$o_assoc(xs, nth(pair, 0), nth(pair, 1))
}
export function _$n_map_$o_filter(xs, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&map:filter', 2, arguments.length);
return reduce(xs, $calcit_procs._$n__$M_(), function _PCT__$n_map_$o_filter(acc, x) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('%&map:filter', 2, arguments.length);

if (f(x)) { return $calcit_procs._$n_map_$o_assoc(acc, nth(x, 0), nth(x, 1)) }else { return acc }
}
)
}
export function _$n_map_$o_filter_kv(xs, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&map:filter-kv', 2, arguments.length);
return reduce(xs, $calcit_procs._$n__$M_(), function _PCT_map_$o_filter_kv(acc, x) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('%map:filter-kv', 2, arguments.length);

if (f(nth(x, 0), nth(x, 1))) { return $calcit_procs._$n_map_$o_assoc(acc, nth(x, 0), nth(x, 1)) }else { return acc }
}
)
}
export function _$n_map_$o_map_list(xs, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&map:map-list', 2, arguments.length);

if (map_$q_(xs)) { return $calcit_procs.foldl(xs, $calcit_procs._$L_(), function _PCT__$n_map_$o_map_list(acc, pair) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('%&map:map-list', 2, arguments.length);
return $calcit_procs.append(acc, f(pair))
}
) }else { let err_AUTO_38 = new Error("&map:map-list expected a map");
 err_AUTO_38.data = null;
 throw err_AUTO_38; }
}
export function keys(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('keys', 1, arguments.length);
return map($calcit_procs.to_pairs(x), $calcit_procs._$n_list_$o_first)
}
export function str(x0, ...xs) { 
if (arguments.length < 1) throw new Error('too few arguments');
xs = arrayToList(xs);

if ($calcit_procs._$n_list_$o_empty_$q_(xs)) { return $calcit_procs._$n_str(x0) }else { return $calcit_procs._$n_str_$o_concat(x0, str(...listToArray(xs))) }
}
export function map_kv(xs, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('map-kv', 2, arguments.length);
(function __fn__(){
( $calcit_procs.not(string_$q_("expects a map")) ? (function __fn__(){
let err_AUTO_39 = new Error("expects 1st argument to be string");
 err_AUTO_39.data = null;
 throw err_AUTO_39;
})() : null );

if (map_$q_(xs)) { return null }else { console.error($calcit_procs.printable("Failed assertion:", $calcit_procs.format_to_lisp(new CalcitSliceList([new CalcitSymbol("map?"), new CalcitSymbol("xs")]))));
let err_AUTO_40 = new Error("expects a map (map? xs)");
 err_AUTO_40.data = null;
 throw err_AUTO_40;
 }

})();
return $calcit_procs.foldl(xs, $calcit_procs._$n__$M_(), function _PCT_map_kv(acc, pair) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('%map-kv', 2, arguments.length);
let result = f(nth(pair, 0), nth(pair, 1));

if (list_$q_(result)) { (function __fn__(){
( $calcit_procs.not(string_$q_("expected pair returned when mapping hashmap")) ? (function __fn__(){
let err_AUTO_41 = new Error("expects 1st argument to be string");
 err_AUTO_41.data = null;
 throw err_AUTO_41;
})() : null );

if ($calcit_procs._$n__$e_(2, $calcit_procs._$n_list_$o_count(result))) { return null }else { console.error($calcit_procs.printable("Failed assertion:", $calcit_procs.format_to_lisp(new CalcitSliceList([new CalcitSymbol("&="), 2, new CalcitSliceList([new CalcitSymbol("&list:count"), new CalcitSymbol("result")])]))));
let err_AUTO_42 = new Error("expected pair returned when mapping hashmap (&= 2 (&list:count result))");
 err_AUTO_42.data = null;
 throw err_AUTO_42;
 }

})();
return $calcit_procs._$n_map_$o_assoc(acc, nth(result, 0), nth(result, 1))
 }
 else if (nil_$q_(result)) { return acc }else { let err_AUTO_43 = new Error(str("map-kv expected list or nil, got: ", result));
 err_AUTO_43.data = null;
 throw err_AUTO_43; }

}
)
}
export function merge(x0, ...xs) { 
if (arguments.length < 1) throw new Error('too few arguments');
xs = arrayToList(xs);
return reduce(xs, x0, $calcit_procs._$n_merge)
}
export function vals(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('vals', 1, arguments.length);
return map($calcit_procs.to_pairs(x), last)
}
export function inc(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('inc', 1, arguments.length);
return $calcit_procs._$n__ADD_(x, 1)
}
export function negate(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('negate', 1, arguments.length);
return $calcit_procs._$n__(0, x)
}
export function _$n_set_$o_filter(xs, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&set:filter', 2, arguments.length);
return reduce(xs, $calcit_procs._SHA__$M_(), function _PCT__$n_set_$o_filter(acc, x) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('%&set:filter', 2, arguments.length);

if (f(x)) { return $calcit_procs._$n_include(acc, x) }else { return acc }
}
)
}
export function _$n_set_$o_max(xs) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('&set:max', 1, arguments.length);

if ($calcit_procs._$n_set_$o_empty_$q_(xs)) { return null }else { return reduce($calcit_procs._$n_set_$o_rest(xs), $calcit_procs._$n_set_$o_first(xs), function _PCT_max(acc, x) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('%max', 2, arguments.length);
return _$n_max(acc, x)
}
) }
}
export function _$n_set_$o_min(xs) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('&set:min', 1, arguments.length);

if ($calcit_procs._$n_set_$o_empty_$q_(xs)) { return null }else { return reduce($calcit_procs._$n_set_$o_rest(xs), $calcit_procs._$n_set_$o_first(xs), function _PCT_min(acc, x) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('%min', 2, arguments.length);
return _$n_min(acc, x)
}
) }
}
export function difference(base, ...xs) { 
if (arguments.length < 1) throw new Error('too few arguments');
xs = arrayToList(xs);
return reduce(xs, base, function f_PCT_(acc, item) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
return $calcit_procs._$n_difference(acc, item)
}
)
}
export function exclude(base, ...xs) { 
if (arguments.length < 1) throw new Error('too few arguments');
xs = arrayToList(xs);
return reduce(xs, base, function f_PCT_(acc, item) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
return $calcit_procs._$n_exclude(acc, item)
}
)
}
export function intersection(base, ...xs) { 
if (arguments.length < 1) throw new Error('too few arguments');
xs = arrayToList(xs);
return reduce(xs, base, function f_PCT_(acc, item) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
return $calcit_procs._$n_set_$o_intersection(acc, item)
}
)
}
export function union(base, ...xs) { 
if (arguments.length < 1) throw new Error('too few arguments');
xs = arrayToList(xs);
return reduce(xs, base, function f_PCT_(acc, item) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
return $calcit_procs._$n_union(acc, item)
}
)
}
export function strip_prefix(s, piece) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('strip-prefix', 2, arguments.length);

if ($calcit_procs.starts_with_$q_(s, piece)) { return $calcit_procs._$n_str_$o_slice(s, $calcit_procs._$n_str_$o_count(piece)) }else { return s }
}
export function strip_suffix(s, piece) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('strip-suffix', 2, arguments.length);

if ($calcit_procs.ends_with_$q_(s, piece)) { return $calcit_procs._$n_str_$o_slice(s, 0, $calcit_procs._$n__($calcit_procs._$n_str_$o_count(s), $calcit_procs._$n_str_$o_count(piece))) }else { return s }
}
export function _$n_init_builtin_classes_$x_() { 
if (arguments.length !== 0) throw _calcit_args_mismatch('&init-builtin-classes!', 0, arguments.length);
identity(_$n_core_number_class);
identity(_$n_core_string_class);
identity(_$n_core_set_class);
identity(_$n_core_list_class);
identity(_$n_core_map_class);
identity(_$n_core_record_class);
identity(_$n_core_nil_class);
return identity(_$n_core_fn_class)
}
export function _$s_(x, ...ys) { 
if (arguments.length < 1) throw new Error('too few arguments');
ys = arrayToList(ys);
return reduce(ys, x, $calcit_procs._$n__$s_)
}
export function _LT__$e_(x, ...ys) { 
if (arguments.length < 1) throw new Error('too few arguments');
ys = arrayToList(ys);

if ($calcit_procs._$n__$e_(1, $calcit_procs._$n_list_$o_count(ys))) { return _$n__LT__$e_(x, $calcit_procs._$n_list_$o_first(ys)) }else { return foldl_compare(ys, x, _$n__LT__$e_) }
}
export function _GT_(x, ...ys) { 
if (arguments.length < 1) throw new Error('too few arguments');
ys = arrayToList(ys);

if ($calcit_procs._$n__$e_(1, $calcit_procs._$n_list_$o_count(ys))) { return $calcit_procs._$n__GT_(x, $calcit_procs._$n_list_$o_first(ys)) }else { return foldl_compare(ys, x, $calcit_procs._$n__GT_) }
}
export function apply(f, args) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('apply', 2, arguments.length);
return f(...listToArray(args))
}
export function assoc_in(data, path, v) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('assoc-in', 3, arguments.length);

if ($calcit_procs._$n_list_$o_empty_$q_(path)) { return v }else { let p0 = $calcit_procs._$n_list_$o_first(path);
let d = ( nil_$q_(data) ? $calcit_procs._$n__$M_() : data );
return assoc(d, p0, assoc_in(( contains_$q_(d, p0) ? get(d, p0) : $calcit_procs._$n__$M_() ), rest(path), v))
 }
}

var bool_$q_ = $calcit_procs.bool_$q_;
export let conj = function conj(xs, y0, ...ys) {
  
if (arguments.length < 2) throw new Error('too few arguments');
  
ys = arrayToList(ys);
  let times_AUTO_46 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_45 = null;
    if (times_AUTO_46 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    
if (empty_$q_(ys)) { ret_AUTO_45 =$calcit_procs.append(xs, y0) }else { ret_AUTO_45 =$calcit_procs.recur($calcit_procs.append(xs, y0), ...listToArray(ys)) }

    if (ret_AUTO_45 instanceof CalcitRecur) {
      
if (ret_AUTO_45.args.length < 2) throw new Error('too few arguments');
      [ xs, y0, ...ys ] = ret_AUTO_45.args;
      
ys = arrayToList(ys);
      times_AUTO_46 += 1;
      continue;
    } else {
      return ret_AUTO_45;
    }
  }
}

export function dissoc(x, ...args) { 
if (arguments.length < 1) throw new Error('too few arguments');
args = arrayToList(args);

if (nil_$q_(x)) { return null }
 else if (list_$q_(x)) { return $calcit_procs._$n_list_$o_dissoc(x, ...listToArray(args)) }else { return $calcit_procs.invoke_method("dissoc",x,...listToArray(args)) }
}
export function dissoc_in(data, path) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('dissoc-in', 2, arguments.length);

if ($calcit_procs._$n_list_$o_empty_$q_(path)) { return null }
 else if ($calcit_procs._$n__$e_(1, $calcit_procs._$n_list_$o_count(path))) { return dissoc(data, $calcit_procs._$n_list_$o_first(path)) }else { let p0 = $calcit_procs._$n_list_$o_first(path);
return assoc(data, p0, dissoc_in(get(data, p0), $calcit_procs._$n_list_$o_rest(path)))
 }
}
export function every_$q_(xs, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('every?', 2, arguments.length);
return $calcit_procs.foldl_shortcut(xs, null, true, function _PCT_every_$q_(_acc, x) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('%every?', 2, arguments.length);

if (f(x)) { return $calcit_procs._$o__$o_(false, null) }else { return $calcit_procs._$o__$o_(true, false) }
}
)
}
export function filter(xs, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('filter', 2, arguments.length);
return $calcit_procs.invoke_method("filter",xs,f)
}
export function first(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('first', 1, arguments.length);

if (nil_$q_(x)) { return null }
 else if (tuple_$q_(x)) { return $calcit_procs._$n_tuple_$o_nth(x, 0) }
 else if (list_$q_(x)) { return $calcit_procs._$n_list_$o_nth(x, 0) }else { return $calcit_procs.invoke_method("first",x,) }
}

var fn_$q_ = $calcit_procs.fn_$q_;
export function frequencies(xs0) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('frequencies', 1, arguments.length);
(function __fn__(){
( $calcit_procs.not(string_$q_("expects a list for frequencies")) ? (function __fn__(){
let err_AUTO_47 = new Error("expects 1st argument to be string");
 err_AUTO_47.data = null;
 throw err_AUTO_47;
})() : null );

if (list_$q_(xs0)) { return null }else { console.error($calcit_procs.printable("Failed assertion:", $calcit_procs.format_to_lisp(new CalcitSliceList([new CalcitSymbol("list?"), new CalcitSymbol("xs0")]))));
let err_AUTO_48 = new Error("expects a list for frequencies (list? xs0)");
 err_AUTO_48.data = null;
 throw err_AUTO_48;
 }

})();
return function f_PCT_(acc, xs) {
  
if (arguments.length !== 2) throw _calcit_args_mismatch('f%', 2, arguments.length);
  
  let times_AUTO_51 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_50 = null;
    if (times_AUTO_51 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    let x0 = $calcit_procs._$n_list_$o_first(xs);

if ($calcit_procs._$n_list_$o_empty_$q_(xs)) { ret_AUTO_50 =acc }else { ret_AUTO_50 =$calcit_procs.recur(( contains_$q_(acc, $calcit_procs._$n_list_$o_first(xs)) ? update(acc, $calcit_procs._$n_list_$o_first(xs), function _PCT__BSL_(_PCT_, _PCT_2) { 
if (arguments.length < 0) throw new Error('too few arguments');
if (arguments.length > 2) throw new Error('too many arguments');
return $calcit_procs._$n__ADD_(_PCT_, 1)
}
) : $calcit_procs._$n_map_$o_assoc(acc, $calcit_procs._$n_list_$o_first(xs), 1) ), rest(xs)) }


    if (ret_AUTO_50 instanceof CalcitRecur) {
      
if (ret_AUTO_50.args.length !== 2) throw _calcit_args_mismatch('f%', 2, ret_AUTO_50.args.length);
      [ acc, xs ] = ret_AUTO_50.args;
      
      times_AUTO_51 += 1;
      continue;
    } else {
      return ret_AUTO_50;
    }
  }
}

($calcit_procs._$n__$M_(), xs0)
}
export function includes_$q_(x, k) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('includes?', 2, arguments.length);

if (nil_$q_(x)) { return false }
 else if (list_$q_(x)) { return $calcit_procs._$n_list_$o_includes_$q_(x, k) }else { return $calcit_procs.invoke_method("includes?",x,k) }
}
export function not_$e_(x, y) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('not=', 2, arguments.length);
return $calcit_procs.not($calcit_procs._$n__$e_(x, y))
}

var ref_$q_ = $calcit_procs.ref_$q_;
export function some_$q_(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('some?', 1, arguments.length);
return $calcit_procs.not(nil_$q_(x))
}
export function symbol_$q_(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('symbol?', 1, arguments.length);
return $calcit_procs._$n__$e_($calcit_procs.type_of(x), _kwd["symbol"])
}
export function update_in(data, path, f) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('update-in', 3, arguments.length);

if ($calcit_procs._$n_list_$o_empty_$q_(path)) { return f(data) }else { let p0 = $calcit_procs._$n_list_$o_first(path);
return assoc(data, p0, update_in(get(data, p0), $calcit_procs._$n_list_$o_rest(path), f))
 }
}



export var _$n_core_fn_class = $calcit_procs._$n__PCT__$M_($calcit_procs.new_record(_kwd["&core-fn-class"], _kwd["call"], _kwd["call-args"], _kwd["map"], _kwd["bind"], _kwd["mappend"], _kwd["apply"]), _kwd["call"], function _$n_fn_$o_call(f, ...args) { 
if (arguments.length < 1) throw new Error('too few arguments');
args = arrayToList(args);
return f(...listToArray(args))
}
, _kwd["call-args"], function _$n_fn_$o_call_args(f, args) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&fn:call-args', 2, arguments.length);
return f(...listToArray(args))
}
, _kwd["map"], function _$n_fn_$o_map(f, g) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&fn:map', 2, arguments.length);
return function _$n_fn_$o_map(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('&fn:map', 1, arguments.length);
return f(g(x))
}

}
, _kwd["bind"], function _$n_fn_$o_bind(m, f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&fn:bind', 2, arguments.length);
return function _PCT__$n_fn_$o_bind(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('%&fn:bind', 1, arguments.length);
return f(m(x), x)
}

}
, _kwd["mappend"], function _$n_fn_$o_mappend(f, g) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&fn:mappend', 2, arguments.length);
return function _PCT__$n_fn_$o_mappend(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('%&fn:mappend', 1, arguments.length);
return $calcit_procs.invoke_method("mappend",f(x),g(x))
}

}
, _kwd["apply"], function _$n_fn_$o_apply(f, g) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&fn:apply', 2, arguments.length);
return function _PCT__$s_fn_$o_apply(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('%*fn:apply', 1, arguments.length);
return g(x, f(x))
}

}
);

export var _$n_core_list_class = $calcit_procs._$n__PCT__$M_($calcit_procs.new_record(_kwd["&core-list-class"], _kwd["any?"], _kwd["add"], _kwd["append"], _kwd["assoc"], _kwd["assoc-after"], _kwd["assoc-before"], _kwd["bind"], _kwd["butlast"], _kwd["concat"], _kwd["contains?"], _kwd["includes?"], _kwd["count"], _kwd["drop"], _kwd["each"], _kwd["empty"], _kwd["empty?"], _kwd["filter"], _kwd["filter-not"], _kwd["find"], _kwd["find-index"], _kwd["find-last"], _kwd["find-last-index"], _kwd["foldl"], _kwd["get"], _kwd["get-in"], _kwd["group-by"], _kwd["index-of"], _kwd["join"], _kwd["join-str"], _kwd["last-index-of"], _kwd["map"], _kwd["map-indexed"], _kwd["mappend"], _kwd["max"], _kwd["min"], _kwd["nth"], _kwd["pairs-map"], _kwd["prepend"], _kwd["reduce"], _kwd["reverse"], _kwd["slice"], _kwd["sort"], _kwd["sort-by"], _kwd["take"], _kwd["take-last"], _kwd["to-set"], _kwd["first"], _kwd["rest"], _kwd["dissoc"], _kwd["to-list"], _kwd["map-pair"], _kwd["filter-pair"], _kwd["apply"], _kwd["flatten"]), _kwd["any?"], any_$q_, _kwd["add"], $calcit_procs.append, _kwd["append"], $calcit_procs.append, _kwd["assoc"], $calcit_procs._$n_list_$o_assoc, _kwd["assoc-after"], $calcit_procs._$n_list_$o_assoc_after, _kwd["assoc-before"], $calcit_procs._$n_list_$o_assoc_before, _kwd["bind"], mapcat, _kwd["butlast"], $calcit_procs.butlast, _kwd["concat"], $calcit_procs._$n_list_$o_concat, _kwd["contains?"], $calcit_procs._$n_list_$o_contains_$q_, _kwd["includes?"], $calcit_procs._$n_list_$o_includes_$q_, _kwd["count"], $calcit_procs._$n_list_$o_count, _kwd["drop"], drop, _kwd["each"], each, _kwd["empty"], function _$n_list_$o_empty(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('&list:empty', 1, arguments.length);
return $calcit_procs._$L_()
}
, _kwd["empty?"], $calcit_procs._$n_list_$o_empty_$q_, _kwd["filter"], _$n_list_$o_filter, _kwd["filter-not"], filter_not, _kwd["find"], find, _kwd["find-index"], find_index, _kwd["find-last"], _$n_list_$o_find_last, _kwd["find-last-index"], _$n_list_$o_find_last_index, _kwd["foldl"], function method_$o_foldl(xs, v0, f) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('method:foldl', 3, arguments.length);
return $calcit_procs.foldl(xs, v0, f)
}
, _kwd["get"], $calcit_procs._$n_list_$o_nth, _kwd["get-in"], get_in, _kwd["group-by"], group_by, _kwd["index-of"], index_of, _kwd["join"], join, _kwd["join-str"], join_str, _kwd["last-index-of"], _$n_list_$o_last_index_of, _kwd["map"], _$n_list_$o_map, _kwd["map-indexed"], map_indexed, _kwd["mappend"], function _$n_list_$o_mappend(x, y) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&list:mappend', 2, arguments.length);
return $calcit_procs._$n_list_$o_concat(x, y)
}
, _kwd["max"], _$n_list_$o_max, _kwd["min"], _$n_list_$o_min, _kwd["nth"], $calcit_procs._$n_list_$o_nth, _kwd["pairs-map"], pairs_map, _kwd["prepend"], $calcit_procs.prepend, _kwd["reduce"], reduce, _kwd["reverse"], $calcit_procs._$n_list_$o_reverse, _kwd["slice"], $calcit_procs._$n_list_$o_slice, _kwd["sort"], function method_$o_sort(x, y) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('method:sort', 2, arguments.length);
return $calcit_procs.sort(x, y)
}
, _kwd["sort-by"], _$n_list_$o_sort_by, _kwd["take"], take, _kwd["take-last"], take_last, _kwd["to-set"], $calcit_procs._$n_list_$o_to_set, _kwd["first"], $calcit_procs._$n_list_$o_first, _kwd["rest"], $calcit_procs._$n_list_$o_rest, _kwd["dissoc"], $calcit_procs._$n_list_$o_dissoc, _kwd["to-list"], identity, _kwd["map-pair"], _$n_list_$o_map_pair, _kwd["filter-pair"], _$n_list_$o_filter_pair, _kwd["apply"], function _$n_fn_$o_apply(xs, fs) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&fn:apply', 2, arguments.length);
return $calcit_procs._$n_list_$o_concat(...listToArray(map(fs, function _$n_fn_$o_ap_gen(f) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('&fn:ap-gen', 1, arguments.length);
return map(xs, function _$n_fn_$o_ap_gen(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('&fn:ap-gen', 1, arguments.length);
return f(x)
}
)
}
)))
}
, _kwd["flatten"], _$n_list_$o_flatten);

export var _$n_core_map_class = $calcit_procs._$n__PCT__$M_($calcit_procs.new_record(_kwd["&core-map-class"], _kwd["add"], _kwd["assoc"], _kwd["contains?"], _kwd["count"], _kwd["dissoc"], _kwd["empty"], _kwd["empty?"], _kwd["filter"], _kwd["filter-kv"], _kwd["get"], _kwd["get-in"], _kwd["includes?"], _kwd["keys"], _kwd["map"], _kwd["map-kv"], _kwd["map-list"], _kwd["mappend"], _kwd["merge"], _kwd["to-list"], _kwd["to-pairs"], _kwd["values"], _kwd["first"], _kwd["rest"], _kwd["diff-new"], _kwd["diff-keys"], _kwd["common-keys"], _kwd["to-map"]), _kwd["add"], _$n_map_$o_add_entry, _kwd["assoc"], $calcit_procs._$n_map_$o_assoc, _kwd["contains?"], $calcit_procs._$n_map_$o_contains_$q_, _kwd["count"], $calcit_procs._$n_map_$o_count, _kwd["dissoc"], $calcit_procs._$n_map_$o_dissoc, _kwd["empty"], function _$n_map_$o_empty(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('&map:empty', 1, arguments.length);
return $calcit_procs._$n__$M_()
}
, _kwd["empty?"], $calcit_procs._$n_map_$o_empty_$q_, _kwd["filter"], _$n_map_$o_filter, _kwd["filter-kv"], _$n_map_$o_filter_kv, _kwd["get"], $calcit_procs._$n_map_$o_get, _kwd["get-in"], get_in, _kwd["includes?"], $calcit_procs._$n_map_$o_includes_$q_, _kwd["keys"], keys, _kwd["map"], _$n_map_$o_map, _kwd["map-kv"], map_kv, _kwd["map-list"], _$n_map_$o_map_list, _kwd["mappend"], merge, _kwd["merge"], merge, _kwd["to-list"], $calcit_procs._$n_map_$o_to_list, _kwd["to-pairs"], $calcit_procs.to_pairs, _kwd["values"], vals, _kwd["first"], $calcit_procs._$n_map_$o_first, _kwd["rest"], $calcit_procs._$n_map_$o_rest, _kwd["diff-new"], $calcit_procs._$n_map_$o_diff_new, _kwd["diff-keys"], $calcit_procs._$n_map_$o_diff_keys, _kwd["common-keys"], $calcit_procs._$n_map_$o_common_keys, _kwd["to-map"], identity);

export var _$n_core_nil_class = $calcit_procs._$n__PCT__$M_($calcit_procs.new_record(_kwd["&core-nil-class"], _kwd["to-list"], _kwd["to-map"], _kwd["pairs-map"], _kwd["to-set"], _kwd["to-string"], _kwd["to-number"], _kwd["map"], _kwd["filter"], _kwd["bind"], _kwd["mappend"], _kwd["apply"]), _kwd["to-list"], function _$n_nil_$o_to_list(_) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('&nil:to-list', 1, arguments.length);
return $calcit_procs._$L_()
}
, _kwd["to-map"], function _$n_nil_$o_to_map(_) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('&nil:to-map', 1, arguments.length);
return $calcit_procs._$n__$M_()
}
, _kwd["pairs-map"], function _$n_nil_$o_pairs_map(_) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('&nil:pairs-map', 1, arguments.length);
return $calcit_procs._$n__$M_()
}
, _kwd["to-set"], function _$n_nil_$o_to_set(_) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('&nil:to-set', 1, arguments.length);
return $calcit_procs._SHA__$M_()
}
, _kwd["to-string"], function _$n_nil_$o_to_string(_) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('&nil:to-string', 1, arguments.length);
return ""
}
, _kwd["to-number"], function _$n_nil_$o_to_number(_) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('&nil:to-number', 1, arguments.length);
return 0
}
, _kwd["map"], function _$n_nil_$o_map(_, _f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&nil:map', 2, arguments.length);
return null
}
, _kwd["filter"], function _$n_nil_$o_filter(_, _f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&nil:filter', 2, arguments.length);
return null
}
, _kwd["bind"], function _$n_nil_$o_bind(_, _f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&nil:bind', 2, arguments.length);
return null
}
, _kwd["mappend"], function _$n_nil_$o_mappend(_, x) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&nil:mappend', 2, arguments.length);
return x
}
, _kwd["apply"], function _$n_nil_$o_apply(_, _f) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('&nil:apply', 2, arguments.length);
return null
}
);

export var _$n_core_number_class = $calcit_procs._$n__PCT__$M_($calcit_procs.new_record(_kwd["&core-number-class"], _kwd["ceil"], _kwd["empty"], _kwd["floor"], _kwd["format"], _kwd["display-by"], _kwd["inc"], _kwd["pow"], _kwd["round"], _kwd["round?"], _kwd["fract"], _kwd["sqrt"], _kwd["negate"], _kwd["rem"]), _kwd["ceil"], $calcit_procs.ceil, _kwd["empty"], function _$n_number_$o_empty(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('&number:empty', 1, arguments.length);
return 0
}
, _kwd["floor"], $calcit_procs.floor, _kwd["format"], $calcit_procs._$n_number_$o_format, _kwd["display-by"], $calcit_procs._$n_number_$o_display_by, _kwd["inc"], inc, _kwd["pow"], $calcit_procs.pow, _kwd["round"], $calcit_procs.round, _kwd["round?"], $calcit_procs.round_$q_, _kwd["fract"], $calcit_procs._$n_number_$o_fract, _kwd["sqrt"], $calcit_procs.sqrt, _kwd["negate"], negate, _kwd["rem"], $calcit_procs._$n_number_$o_rem);

export var _$n_core_record_class = $calcit_procs._$n__PCT__$M_($calcit_procs.new_record(_kwd["&core-record-class"], _kwd["get"], _kwd["get-name"], _kwd["matches?"], _kwd["to-map"], _kwd["count"], _kwd["contains?"], _kwd["assoc"], _kwd["from-map"], _kwd["extend-as"]), _kwd["get"], $calcit_procs._$n_record_$o_get, _kwd["get-name"], $calcit_procs._$n_record_$o_get_name, _kwd["matches?"], $calcit_procs._$n_record_$o_matches_$q_, _kwd["to-map"], $calcit_procs._$n_record_$o_to_map, _kwd["count"], $calcit_procs._$n_record_$o_count, _kwd["contains?"], $calcit_procs._$n_record_$o_contains_$q_, _kwd["assoc"], $calcit_procs._$n_record_$o_assoc, _kwd["from-map"], $calcit_procs._$n_record_$o_from_map, _kwd["extend-as"], $calcit_procs._$n_record_$o_extend_as);

export var _$n_core_set_class = $calcit_procs._$n__PCT__$M_($calcit_procs.new_record(_kwd["&core-set-class"], _kwd["add"], _kwd["count"], _kwd["difference"], _kwd["exclude"], _kwd["empty"], _kwd["empty?"], _kwd["filter"], _kwd["include"], _kwd["includes?"], _kwd["contains?"], _kwd["intersection"], _kwd["max"], _kwd["min"], _kwd["to-list"], _kwd["union"], _kwd["first"], _kwd["rest"], _kwd["to-set"], _kwd["mappend"]), _kwd["add"], include, _kwd["count"], $calcit_procs._$n_set_$o_count, _kwd["difference"], difference, _kwd["exclude"], exclude, _kwd["empty"], function _$n_set_$o_empty(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('&set:empty', 1, arguments.length);
return $calcit_procs._SHA__$M_()
}
, _kwd["empty?"], $calcit_procs._$n_set_$o_empty_$q_, _kwd["filter"], _$n_set_$o_filter, _kwd["include"], include, _kwd["includes?"], $calcit_procs._$n_set_$o_includes_$q_, _kwd["contains?"], $calcit_procs._$n_set_$o_includes_$q_, _kwd["intersection"], intersection, _kwd["max"], _$n_set_$o_max, _kwd["min"], _$n_set_$o_min, _kwd["to-list"], $calcit_procs._$n_set_$o_to_list, _kwd["union"], union, _kwd["first"], $calcit_procs._$n_set_$o_first, _kwd["rest"], $calcit_procs._$n_set_$o_rest, _kwd["to-set"], identity, _kwd["mappend"], union);

export var _$n_core_string_class = $calcit_procs._$n__PCT__$M_($calcit_procs.new_record(_kwd["&core-string-class"], _kwd["blank?"], _kwd["count"], _kwd["empty"], _kwd["ends-with?"], _kwd["get"], _kwd["parse-float"], _kwd["replace"], _kwd["split"], _kwd["split-lines"], _kwd["starts-with?"], _kwd["strip-prefix"], _kwd["strip-suffix"], _kwd["slice"], _kwd["trim"], _kwd["empty?"], _kwd["contains?"], _kwd["includes?"], _kwd["nth"], _kwd["first"], _kwd["rest"], _kwd["pad-left"], _kwd["pad-right"], _kwd["find-index"], _kwd["get-char-code"], _kwd["escape"], _kwd["mappend"]), _kwd["blank?"], $calcit_procs.blank_$q_, _kwd["count"], $calcit_procs._$n_str_$o_count, _kwd["empty"], function _$n_str_$o_empty(_) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('&str:empty', 1, arguments.length);
return ""
}
, _kwd["ends-with?"], $calcit_procs.ends_with_$q_, _kwd["get"], $calcit_procs._$n_str_$o_nth, _kwd["parse-float"], $calcit_procs.parse_float, _kwd["replace"], $calcit_procs._$n_str_$o_replace, _kwd["split"], $calcit_procs.split, _kwd["split-lines"], $calcit_procs.split_lines, _kwd["starts-with?"], $calcit_procs.starts_with_$q_, _kwd["strip-prefix"], strip_prefix, _kwd["strip-suffix"], strip_suffix, _kwd["slice"], $calcit_procs._$n_str_$o_slice, _kwd["trim"], $calcit_procs.trim, _kwd["empty?"], $calcit_procs._$n_str_$o_empty_$q_, _kwd["contains?"], $calcit_procs._$n_str_$o_contains_$q_, _kwd["includes?"], $calcit_procs._$n_str_$o_includes_$q_, _kwd["nth"], $calcit_procs._$n_str_$o_nth, _kwd["first"], $calcit_procs._$n_str_$o_first, _kwd["rest"], $calcit_procs._$n_str_$o_rest, _kwd["pad-left"], $calcit_procs._$n_str_$o_pad_left, _kwd["pad-right"], $calcit_procs._$n_str_$o_pad_right, _kwd["find-index"], $calcit_procs._$n_str_$o_find_index, _kwd["get-char-code"], $calcit_procs.get_char_code, _kwd["escape"], $calcit_procs._$n_str_$o_escape, _kwd["mappend"], $calcit_procs._$n_str_$o_concat);


$calcit_procs.register_calcit_builtin_classes({
  list: _$n_core_list_class,
  map: _$n_core_map_class,
  number: _$n_core_number_class,
  record: _$n_core_record_class,
  set: _$n_core_set_class,
  string: _$n_core_string_class,
  nil: _$n_core_nil_class,
  fn: _$n_core_fn_class,
});

let runtimeVersion = $calcit_procs.calcit_version;
let cli_version = '0.6.24';

if (runtimeVersion !== cli_version) {
  console.warn(`[Warning] versions mismatch, CLI using: ${cli_version}, runtime using: ${runtimeVersion}`)
}
