
import * as $calcit from "./calcit.core.mjs";
import { literal_$q_ } from "./recollect.util.mjs";
import * as $recollect_DOT_schema from "./recollect.schema.mjs";
var _kwd={};
["id","key",].forEach(x => {
  _kwd[x] = $calcit.kwd(x);
});


let _calcit_args_mismatch = (name, expected, got) => {
  return new Error(`\`${name}\` expected ${expected} params, got ${got}`);
};

export function by_key(x, y) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('by-key', 2, arguments.length);
return $calcit._$n_compare($calcit.first(x), $calcit.first(y))
}
export function diff_set(collect_$x_, coord, a, b) { 
if (arguments.length !== 4) throw _calcit_args_mismatch('diff-set', 4, arguments.length);
let added = $calcit.difference(b, a);
let removed = $calcit.difference(a, b);
return collect_$x_($calcit._$L_($recollect_DOT_schema.tree_op_set_splice, coord, $calcit._$L_(removed, added)))

}
export let find_vector_changes = function find_vector_changes(collect_$x_, idx, coord, a_items, b_items, options) {
  
if (arguments.length !== 6) throw _calcit_args_mismatch('find-vector-changes', 6, arguments.length);
  
  let times_AUTO_3 = 0;
  while(true) { /* Tail Recursion */
    let ret_AUTO_2 = null;
    if (times_AUTO_3 > 10000000) throw new Error('tail recursion not finished after 10M iterations');
    
if (( $calcit.empty_$q_(a_items) ? (function __fn__(){
let v1__3 = $calcit.empty_$q_(b_items);

if (v1__3) { return v1__3 }else { return false }

})() : false )) { ret_AUTO_2 =null }
 else if ($calcit.empty_$q_(b_items)) { ret_AUTO_2 =collect_$x_($calcit._$L_($recollect_DOT_schema.tree_op_vec_drop, coord, idx)) }
 else if ($calcit.empty_$q_(a_items)) { ret_AUTO_2 =collect_$x_($calcit._$L_($recollect_DOT_schema.tree_op_vec_append, coord, b_items)) }else { diff_twig_iterate(collect_$x_, $calcit.conj(coord, idx), $calcit.first(a_items), $calcit.first(b_items), options);
ret_AUTO_2 =$calcit.recur(collect_$x_, $calcit.inc(idx), coord, $calcit.rest(a_items), $calcit.rest(b_items), options)
 }

    if (ret_AUTO_2 instanceof $calcit.CalcitRecur) {
      
if (ret_AUTO_2.args.length !== 6) throw _calcit_args_mismatch('find-vector-changes', 6, ret_AUTO_2.args.length);
      [ collect_$x_, idx, coord, a_items, b_items, options ] = ret_AUTO_2.args;
      
      times_AUTO_3 += 1;
      continue;
    } else {
      return ret_AUTO_2;
    }
  }
}

export function diff_vector(collect_$x_, coord, a, b, options) { 
if (arguments.length !== 5) throw _calcit_args_mismatch('diff-vector', 5, arguments.length);
return find_vector_changes(collect_$x_, 0, coord, a, b, options)
}
export function diff_twig_iterate(collect_$x_, coord, a, b, options) { 
if (arguments.length !== 5) throw _calcit_args_mismatch('diff-twig-iterate', 5, arguments.length);

if ($calcit.identical_$q_(a, b)) { return null }
 else if ($calcit._$e_($calcit.type_of(a), $calcit.type_of(b))) { 
if (literal_$q_(b)) { return collect_$x_($calcit._$L_($recollect_DOT_schema.tree_op_assoc, coord, b)) }
 else if ($calcit.symbol_$q_(b)) { return collect_$x_($calcit._$L_($recollect_DOT_schema.tree_op_assoc, coord, b)) }
 else if ($calcit.map_$q_(b)) { return diff_map(collect_$x_, coord, a, b, options) }
 else if ($calcit.set_$q_(b)) { return diff_set(collect_$x_, coord, a, b) }
 else if ($calcit.list_$q_(b)) { return diff_vector(collect_$x_, coord, a, b, options) }
 else if ($calcit.record_$q_(b)) { return diff_record(collect_$x_, coord, a, b, options) }
 else if ($calcit.ref_$q_(b)) { console.log($calcit.printable("[Error] unexpected ref to compare")) }else { console.log($calcit.printable("[Warning] unexpected data:", a, b))
 } }else { return collect_$x_($calcit._$L_($recollect_DOT_schema.tree_op_assoc, coord, b)) }
}
export function diff_record(collect_$x_, coord, a, b, options) { 
if (arguments.length !== 5) throw _calcit_args_mismatch('diff-record', 5, arguments.length);

if ($calcit.identical_$q_(a, b)) { return null }
 else if ($calcit.invoke_method("matches?",a,b)) { let a_pairs = $calcit.to_pairs(a);
return $calcit.foldl(a_pairs, null, function doseq_fn_PCT_(_acc, pair) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('doseq-fn%', 2, arguments.length);
let k = $calcit._$n_list_$o_nth(pair, 0);
let va = $calcit._$n_list_$o_nth(pair, 1);
return diff_twig_iterate(collect_$x_, $calcit.conj(coord, k), va, $calcit._$n_record_$o_get(b, k), options)

}
)
 }else { return collect_$x_($calcit._$L_($recollect_DOT_schema.tree_op_assoc, coord, b)) }
}
export function diff_map(collect_$x_, coord, a, b, options) { 
if (arguments.length !== 5) throw _calcit_args_mismatch('diff-map', 5, arguments.length);
let id_k = ( $calcit.nil_$q_(options) ? _kwd["id"] : $calcit._$n_map_$o_get(options, _kwd["key"]) );
let ka = $calcit._$n_map_$o_get(a, id_k);
let kb = $calcit._$n_map_$o_get(b, id_k);

if (( $calcit.some_$q_(ka) ? (function __fn__(){
let v1__1 = $calcit.not_$e_(ka, kb);

if (v1__1) { return v1__1 }else { return false }

})() : false )) { return collect_$x_($calcit._$L_($recollect_DOT_schema.tree_op_assoc, coord, b)) }else { let new_diff = $calcit._$n_map_$o_diff_new(b, a);
let drop_keys = $calcit._$n_map_$o_diff_keys(a, b);
let common_keys = $calcit._$n_map_$o_common_keys(a, b);
let a_pairs = $calcit.sort($calcit._$n_map_$o_to_list(a), by_key);
let b_pairs = $calcit.sort($calcit._$n_map_$o_to_list(b), by_key);
( $calcit.not(( $calcit._$n_set_$o_empty_$q_(drop_keys) ? (function __fn__(){
let v1__2 = $calcit._$n_map_$o_empty_$q_(new_diff);

if (v1__2) { return v1__2 }else { return false }

})() : false )) ? collect_$x_($calcit._$L_($recollect_DOT_schema.tree_op_map_splice, coord, $calcit._$L_(drop_keys, new_diff))) : null );
return $calcit.foldl(common_keys, null, function doseq_fn_PCT_(_acc, common_k) { 
if (arguments.length !== 2) throw _calcit_args_mismatch('doseq-fn%', 2, arguments.length);
let va = $calcit._$n_map_$o_get(a, common_k);
let vb = $calcit._$n_map_$o_get(b, common_k);

if ($calcit.not_$e_(va, vb)) { return diff_twig_iterate(collect_$x_, $calcit.conj(coord, common_k), va, vb, options) }else { return  null; }

}
)
 }

}
export function diff_twig(a, b, options) { 
if (arguments.length !== 3) throw _calcit_args_mismatch('diff-twig', 3, arguments.length);

if ($calcit.identical_$q_(a, b)) { return $calcit._$L_() }else { let _$s_changes = _$s_diff_changes;
let collect_$x_ = function f_PCT_(x) { 
if (arguments.length !== 1) throw _calcit_args_mismatch('f%', 1, arguments.length);
return $calcit.reset_$x_(_$s_changes, $calcit.conj($calcit.deref(_$s_changes), x))
}
;
$calcit.reset_$x_(_$s_changes, $calcit._$L_());
diff_twig_iterate(collect_$x_, $calcit._$L_(), a, b, options);
return $calcit.deref(_$s_changes)
 }
}



export var _$s_diff_changes = 
($calcit.peekDefatom("recollect.diff/*diff-changes") ?? $calcit.defatom("recollect.diff/*diff-changes", $calcit._$L_()))
;

